/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Contents of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph


Revision 1.26 - (show annotations) (download)
Fri Dec 5 14:56:45 2003 UTC (16 years, 3 months ago) by edhill
Branch: MAIN
Changes since 1.25: +4 -1 lines
 o export "CC=cc" so we have a saner default compiler for mpack

1 #! /usr/bin/env bash
2 #
3 # $Header: /u/u3/gcmpack/MITgcm/verification/testreport,v 1.25 2003/12/04 16:36:18 edhill Exp $
4 # $Name: $
5 #
6
7 usage()
8 {
9 echo
10 echo "Usage: $0 [OPTIONS]"
11 echo
12 echo "where possible OPTIONS are:"
13 echo " (-help|-h) print usage"
14 echo " (-mpi) use MPI input files"
15 echo " (-ieee|-noieee) if possible, use IEEE compiler flags"
16 echo " (DEF=\"noieee\")"
17 echo " (-optfile=|-of=)STRING list of optfiles to use"
18 echo " (-a|-addr) STRING list of email recipients"
19 echo " (DEF=\"edhill@mitgcm.org\")"
20 echo " (-t|-tdir) STRING list of test dirs to use"
21 echo " (DEF=\"\" which builds all)"
22 echo " (-b|-bash) STRING preferred location of a \"bash\" or"
23 echo " Bourne-compatible \"sh\" shell"
24 echo " (DEF=\"\" for \"bash\")"
25 echo " (-adm|-ad) perform an adjoint run"
26 echo " (-command) STRING command to run"
27 echo " (DEF=\"make output.txt\")"
28 echo " (-m|-make) STRING command to use for \"make\""
29 echo " (DEF=\"make\")"
30 echo " (-clean) *ONLY* run \"make CLEAN\""
31 echo " (-quick|-q) same as \"-nogenmake -noclean -nodepend\""
32 echo " (-nogenmake|-ng) skip the genmake stage"
33 echo " (-noclean|-nc) skip the \"make clean\" stage"
34 echo " (-nodepend|-nd) skip the \"make depend\" stage"
35 echo
36 echo "and where STRING follows a whitespace-delimited format"
37 echo "such as:"
38 echo " -t 'exp0 exp2 exp3' "
39 echo " -addr='abc@123.com testing@home.org'"
40 echo
41 exit 1
42 }
43
44 # build the mpack utility
45 build_mpack()
46 {
47 echo -n "building the mpack utility... "
48 if test ! -x "$MPACKDIR/mpack" ; then
49 if test ! -d $MPACKDIR ; then
50 echo
51 echo "Error: can't find \"$MPACKDIR\""
52 echo " are you sure this program is being run in the correct "
53 echo " (that is, \"MITGCM_ROOT\verification\") directory?"
54 echo
55 HAVE_MPACK=f
56 fi
57 echo -n "building mpack... "
58 if test "x$CC" = x ; then
59 export CC=cc
60 fi
61 ( cd $MPACKDIR && ./configure && $MAKE ) > tr_build_mpack.out 2>&1
62 RETVAL=$?
63 if test "x$RETVAL" != x0 ; then
64 echo
65 echo "Error building the mpack tools at: $MPACK_DIR"
66 echo
67 HAVE_MPACK=f
68 else
69 rm -f tr_build_mpack.out
70 HAVE_MPACK=t
71 fi
72 else
73 HAVE_MPACK=t
74 fi
75 echo "OK"
76 }
77
78 testoutput_for_prop()
79 {
80 # testoutput_for_prop dir s1 label subdir
81 #
82 # compares files in $dir/$subdir/output.txt and $dir/results/output.txt
83 # using search strings s1 and text label
84
85 if [ $debug -gt 0 ]; then
86 echo testoutput_for_prop: grep "$2" $1/$4/output.txt 1>&2
87 fi
88 if [ -r $1/$4/output.txt ]; then
89 grep "$2" $1/$4/output.txt | sed 's/.*=//' | cat -n > tmp1.txt
90 lncnt=`wc -l tmp1.txt | awk '{print $1}' `
91 if [ $lncnt -lt 3 ]; then
92 if [ $verbose -gt 0 ]; then
93 echo Not enough lines of output when searching for "$2" 1>&2
94 fi
95 return 99
96 fi
97 else
98 echo testoutput_for_prop: output.txt from model run was not readable 1>&2
99 return 99
100 fi
101 if [ $debug -gt 0 ]; then
102 echo testoutput_for_prop: grep "$2" $1/results/output.txt 1>&2
103 fi
104 grep "$2" $1/results/output.txt | sed 's/.*=//' | cat -n > tmp2.txt
105 lncnt=`wc -l tmp2.txt | awk '{print $1}' `
106 if [ $lncnt -lt 3 ]; then
107 if [ $verbose -gt 0 ]; then
108 echo Not enough lines of output when searching for "$2" 1>&2
109 fi
110 return 99
111 fi
112 if [ $debug -gt 0 ]; then
113 echo testoutput_for_prop: join tmp1.txt tmp2.txt 1>&2
114 fi
115 join tmp1.txt tmp2.txt | awk '{print $1 " " $2 " " $3}' > tmp3.txt
116 if [ $debug -gt 0 ]; then
117 echo testoutput_for_prop: compare_lines 1>&2
118 fi
119 if [ $verbose -gt 1 ]; then
120 cat tmp3.txt 1>&2
121 fi
122 echo "-1" >> tmp3.txt
123 # On the SGI O3K (*not* the O2K), "cat -n" inserts a ":" after the line number
124 cat tmp3.txt | sed -e 's|:||g' > tmp4.txt
125 digits_of_similarity=`./tmp_cmpnum < tmp4.txt`
126 if [ $digits_of_similarity -eq 99 ]; then
127 if [ $verbose -gt 0 ]; then
128 echo testoutput_for_prop: No comparison was available for \"$2\" 1>&2
129 fi
130 digits_of_similarity=99
131 else
132 if [ $verbose -gt 0 ]; then
133 echo There were $digits_of_similarity decimal places of similarity for \"$2\" 1>&2
134 fi
135 fi
136 rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt
137
138 return $digits_of_similarity
139 }
140
141 dashnum()
142 {
143 # dashnum n1 n2 n3 ...
144 #
145 # print numbers using %3i format or "--" if number = 99
146
147 for num in $@ ; do
148 if [ $num = 99 ]; then
149 printf ' --'
150 else
151 printf '%3i' $num
152 fi
153 done
154 }
155
156 testoutput_ad()
157 {
158 grep $3 $1/results_ad/output.txt_adm | awk '{print NR " " $5}' > t05.txt
159 grep $3 $1/$2/output.txt_adm | awk '{print NR " " $5}' > t15.txt
160 grep $3 $1/results_ad/output.txt_adm | awk '{print NR " " $6}' > t06.txt
161 grep $3 $1/$2/output.txt_adm | awk '{print NR " " $6}' > t16.txt
162 join t05.txt t15.txt > t5.txt
163 join t06.txt t16.txt > t6.txt
164 echo "-1" >> t5.txt
165 echo "-1" >> t6.txt
166 digits_5=`./tmp_cmpnum < t5.txt`
167 digits_6=`./tmp_cmpnum < t6.txt`
168 dashnum $digits_5 $digits_6
169 rm -f t[01][56].txt t[56].txt
170 }
171
172 testoutput()
173 {
174 # testoutput directory subdir
175 #
176 # test output in "directory"
177 if test "x$ADM" = x ; then
178 if [ $debug -gt 0 ]; then
179 echo testoutput: testoutput_for_prop $1 cg2d_init_res 1>&2
180 fi
181 testoutput_for_prop $1 "cg2d_init_res" "cg2d init. residual" $2; cg2dres=$?
182 if [ $debug -gt 0 ]; then
183 echo testoutput: cg2dres=$cg2dres 1>&2
184 fi
185 testoutput_for_prop $1 "dynstat_theta_min" "theta minimum" $2; tmin=$?
186 testoutput_for_prop $1 "dynstat_theta_max" "theta maximum" $2; tmax=$?
187 testoutput_for_prop $1 "dynstat_theta_mean" "theta mean" $2; tmean=$?
188 testoutput_for_prop $1 "dynstat_theta_sd" "theta s.d." $2; tsd=$?
189 testoutput_for_prop $1 "dynstat_salt_min" "salt minimum" $2; smin=$?
190 testoutput_for_prop $1 "dynstat_salt_max" "salt maximum" $2; smax=$?
191 testoutput_for_prop $1 "dynstat_salt_mean" "salt mean" $2; smean=$?
192 testoutput_for_prop $1 "dynstat_salt_sd" "salt s.d." $2; ssd=$?
193 testoutput_for_prop $1 "dynstat_uvel_min" "U minimum" $2; umin=$?
194 testoutput_for_prop $1 "dynstat_uvel_max" "U maximum" $2; umax=$?
195 testoutput_for_prop $1 "dynstat_uvel_mean" "U mean" $2; umean=$?
196 testoutput_for_prop $1 "dynstat_uvel_sd" "U s.d." $2; usd=$?
197 testoutput_for_prop $1 "dynstat_vvel_min" "V minimum" $2; vmin=$?
198 testoutput_for_prop $1 "dynstat_vvel_max" "V maximum" $2; vmax=$?
199 testoutput_for_prop $1 "dynstat_vvel_mean" "V mean" $2; vmean=$?
200 testoutput_for_prop $1 "dynstat_vvel_sd" "V s.d." $2; vsd=$?
201 dashnum $cg2dres $tmin $tmax $tmean $tsd $smin $smax $smean $ssd \
202 $umin $umax $umean $usd $vmin $vmax $vmean $vsd
203 else
204 testoutput_ad $1 $2 "precision_grdchk_result"
205 fi
206 }
207
208 genmakemodel()
209 {
210 # genmakemodel directory
211 if test "x$NOGENMAKE" = xt ; then
212 echo "genmake skipped!"
213 else
214 GENMAKE2="$BASH ../../../tools/genmake2"
215 (
216 cd $1;
217 command="$GENMAKE2 -ds -m $MAKE"
218 if test "x$ADM" = x ; then
219 command="$command --mods=../code"
220 else
221 command="$command --mods=../code_ad"
222 command="$command -adof=../../../tools/adjoint_options/adjoint_staf"
223 fi
224 if test "x$OPTFILE" != xNONE ; then
225 command="$command --optfile=$OPTFILE"
226 fi
227 if test "x$IEEE" != x ; then
228 command="$command -ieee"
229 fi
230 printf 'genmake ... ' 1>&2
231 $command > make.log 2>&1
232 RETVAL=$?
233 cp Makefile $CDIR
234 if test "x$RETVAL" != x0 ; then
235 tail make.log
236 echo "genmakemodel: genmake failed" 1>&2
237 cp genmake_* make.log $CDIR
238 return 1
239 else
240 echo "successful" 1>&2
241 fi
242 )
243 fi
244 }
245
246 makeclean()
247 {
248 # makeclean directory
249 if test "x$NOCLEAN" = xt ; then
250 echo "make CLEAN skipped!"
251 else
252 (
253 cd $1;
254 if test -e output.txt ; then
255 rm -f output.txt
256 fi
257 printf 'make CLEAN ... ' 2>&1
258 if test -r Makefile ; then
259 $MAKE CLEAN >> make.log 2>&1
260 RETVAL=$?
261 if test "x$RETVAL" != x0 ; then
262 tail make.log
263 echo "makeclean: \"make CLEAN\" failed" 1>&2
264 cp make.log $CDIR"/make.log"
265 return 1
266 fi
267 fi
268 echo successful 1>&2
269 exit 0
270 )
271 fi
272 }
273
274 makedependmodel()
275 {
276 # makedependmodel directory
277 if test "x$NODEPEND" = xt ; then
278 echo "make depend skipped!"
279 else
280 (
281 cd $1;
282 printf 'make depend ... ' 1>&2
283 $MAKE depend >> make.log 2>&1
284 RETVAL=$?
285 if test "x$RETVAL" != x0 ; then
286 tail make.log
287 echo "makedependmodel: make depend failed" 1>&2
288 cp make.log $CDIR"/make.log"
289 return 1
290 else
291 echo successful 1>&2
292 fi
293 )
294 fi
295 }
296
297 makemodel()
298 {
299 # makemodel directory
300 (
301 cd $1;
302 if test -r Makefile ; then
303 printf 'make ... ' 1>&2
304 if test "x$ADM" = x ; then
305 $MAKE >> make.log 2>&1
306 else
307 $MAKE adall >> make.log 2>&1
308 fi
309 RETVAL=$?
310 if test "x$RETVAL" != x0 ; then
311 tail make.log
312 echo failed 1>&2
313 cp make.log $CDIR"/make.log"
314 return 1
315 else
316 echo successful 1>&2
317 fi
318 fi
319 )
320 }
321
322 linkdata()
323 {
324 # linkdata flag
325 #
326 # symbolically link data files to run directory
327 if test "x$1" = x1 ; then
328 (
329 cd $2
330 if test "x$ADM" = x ; then
331 files=`( cd ../input ; ls -1 | grep -v CVS )`
332 for i in $files ; do
333 if test ! -d "../input/"$i ; then
334 ln -sf "../input/"$i $i
335 fi
336 done
337 else
338 files=`( cd ../input ; ls -1 *.bin | grep -v CVS )`
339 for i in $files ; do
340 if test ! -d "../input/"$i ; then
341 ln -sf "../input/"$i $i
342 fi
343 done
344 files=`( cd ../input_ad ; ls -1 | grep -v CVS )`
345 for i in $files ; do
346 if test ! -d "../input_ad/"$i ; then
347 ln -sf "../input_ad/"$i $i
348 fi
349 done
350 fi
351 )
352 fi
353 }
354
355 runmodel()
356 {
357 # runmodel directory
358 #
359 # runs "$COMMAND in "directory"
360 # (where "$COMMAND" is relative to "directory")
361 (
362 cd $1
363 printf 'runmodel ... ' 1>&2
364 # make output.txt
365 $COMMAND >> run.log 2>&1
366 RETVAL=$?
367 if test "x$RETVAL" = x0 ; then
368 echo successful 1>&2
369 if test "x$ADM" = x ; then
370 cp output.txt $CDIR"/output.txt"
371 else
372 cp output.txt_adm $CDIR"/output.txt_adm"
373 fi
374 return 0
375 else
376 tail run.log
377 echo failed 1>&2
378 cp run.log $CDIR"/run.log"
379 return 1
380 fi
381 )
382 }
383
384 createcodelet()
385 {
386 # create codelet for comparing model output
387
388 echo -n "creating the comparison code... "
389 cat > tmp_cmpnum.c <<EOF
390 #include <stdio.h>
391 #include <math.h>
392 int main( int argc, char** argv ) {
393 int linnum,best;
394 double a,b,diff;
395 best = -16;
396 while( 1 ) {
397 scanf("%d", &linnum);
398 if (linnum == -1) break;
399 scanf("%lf", &a); scanf("%lf", &b);
400 diff = 0.5*(fabs(a)+fabs(b));
401 if (diff > 1.e-12) {
402 diff=fabs(a-b)/diff;
403 if (diff > 0.0) {
404 linnum = (int)log10(diff);
405 best = (best > linnum) ? best : linnum;
406 }
407 else {
408 if (best == -16 && diff != 0) best = -22;
409 }
410 }
411 }
412 printf("%d\n", -best);
413 return 0;
414 }
415 EOF
416 cc -o tmp_cmpnum tmp_cmpnum.c -lm
417
418 if [ -x ./tmp_cmpnum ]; then
419 echo "OK"
420 return 0
421 else
422 echo
423 echo "ERROR: failed to compile comparison code"
424 exit 1
425 fi
426 }
427
428 formatresults()
429 {
430 # formatresults expt genmake depend make run results*
431
432 nm=$1
433 printf '%s %s %s %s' $2 $3 $4 $5
434 shift; shift; shift; shift; shift;
435 printf '%3s' $@
436
437 if [ $1 = '--' ]; then
438 printf ' N/O '
439 else
440 if [ $1 -gt 12 ]; then
441 printf ' pass'
442 else
443 printf ' FAIL'
444 fi
445 fi
446 printf ' %s' $nm
447 printf '\n'
448
449 }
450
451 show_help()
452 {
453 cat - << EOF
454 $0 [-help] [-quick] [-verbose] dir1 [dir2] [...]
455
456 -help|-h Show this help message
457 -quiet Reduce the amount of output
458 -verbose Produce copious amounts of output
459 -debug Produce even more output which will mean nothing to most
460 -force Do "make CLEAN" before compiling. This forces a complete rebuild.
461 -clean Do "make CLEAN" after compiling and testing.
462 -cleanup Aggresively removes all model output, executables and object files
463 and then exits. Use with care.
464
465 Normal usage:
466 $0 * Configure, compile, run and analyze in all experiment directories
467 EOF
468 }
469
470 scandirs()
471 {
472 if [ $# -eq 0 ]; then
473 for arg in * ; do
474 test -d $arg/input && echo $arg
475 done
476 else
477 echo $*
478 fi
479 }
480
481
482 ###############################################################################
483
484
485 # Default properties
486 debug=0
487 verbose=1
488 clean=0
489 expts=''
490 # ieee=1
491
492 IEEE=
493 if test "x$MITGCM_IEEE" != x ; then
494 IEEE=$MITGCM_IEEE
495 fi
496
497
498 CLEANUP=f
499 QUICK=f
500 NOGENMAKE=f
501 NOCLEAN=f
502 NODEPEND=f
503
504 BASH=
505 OPTFILE=NONE
506 ADDRESSES=
507 TESTDIRS=
508 MPACKDIR="../tools/mpack-1.6"
509 HAVE_MPACK=
510 MPACK="$MPACKDIR/mpack"
511 COMMAND=
512 MAKE=make
513 MPI=f
514
515 ADM=
516
517 echo -n "parsing options... "
518
519 ac_prev=
520 for ac_option ; do
521
522 # If the previous option needs an argument, assign it.
523 if test -n "$ac_prev"; then
524 eval "$ac_prev=\$ac_option"
525 ac_prev=
526 continue
527 fi
528
529 ac_optarg=`expr "x$ac_option" : 'x[^=]*=\(.*\)'`
530
531 case $ac_option in
532
533 -help | --help | -h | --h)
534 usage ;;
535
536 -optfile | --optfile | -of | --of)
537 ac_prev=OPTFILE ;;
538 -optfile=* | --optfile=* | -of=* | --of=*)
539 OPTFILE=$ac_optarg ;;
540
541 -addr | --addr | -a | --a)
542 ac_prev=ADDRESSES ;;
543 -addr=* | --addr=*)
544 ADDRESSES=$ac_optarg ;;
545
546 -tdir | --tdir | -t | --t)
547 ac_prev=TESTDIRS ;;
548 -tdir=* | --tdir=*)
549 TESTDIRS=$ac_optarg ;;
550
551 -bash | --bash | -b | --b)
552 ac_prev=BASH ;;
553 -bash=* | --bash=*)
554 BASH=$ac_optarg ;;
555
556 -command | --command | -c | --c)
557 ac_prev=COMMAND ;;
558 -command=* | --command=*)
559 COMMAND=$ac_optarg ;;
560
561 -make | --make | -m | --m)
562 ac_prev=MAKE ;;
563 -make=* | --make=*)
564 MAKE=$ac_optarg ;;
565
566 -clean | --clean)
567 CLEANUP=t ;;
568
569 -quick | --quick | -q | --q)
570 QUICK=t ;;
571 -nogenmake | --nogenmake | -ng | --ng)
572 NOGENMAKE=t ;;
573 -noclean | --noclean | -nc | --nc)
574 NOCLEAN=t ;;
575 -nodepend | --nodepend | -nd | --nd)
576 NODEPEND=t ;;
577
578 -mpi) MPI=t ;;
579
580 -adm | -ad) ADM=t ;;
581
582 -ieee) IEEE=true ;;
583 -noieee) IEEE= ;;
584
585 -verbose) verbose=2 ;;
586 -debug) debug=1 ;;
587 -quiet) verbose=0 ;;
588
589 -*)
590 echo "Error: unrecognized option: "$ac_option
591 usage
592 ;;
593
594 *)
595 echo "Error: unrecognized argument: "$ac_option
596 usage
597 ;;
598
599 esac
600
601 done
602
603 if test "x$QUICK" = xt ; then
604 NOGENMAKE=t
605 NOCLEAN=t
606 NODEPEND=t
607 fi
608
609 if test "x$TESTDIRS" = x ; then
610 TESTDIRS=`scandirs`
611 fi
612
613 if test "x$OPTFILE" = xNONE -a "x$MITGCM_OF" != x ; then
614 OPTFILE=$MITGCM_OF
615 fi
616
617 if test "x$ADM" = xt -a "x$COMMAND" = x ; then
618 COMMAND="./mitgcmuv_ad > output.txt_adm 2>&1"
619 fi
620
621 if test "x$COMMAND" = x ; then
622 COMMAND="make output.txt"
623 fi
624
625 echo "OK"
626
627 # create the FORTRAN comparison code
628 createcodelet
629
630 # build the mpack utility
631 build_mpack
632
633 # Create a uniquely named directory to store results
634 MACH=`hostname`
635 UNAMEA=`uname -a`
636 DATE=`date +%Y%m%d`
637 BASE="tr_"$MACH"_"$DATE"_"
638 DNUM=0
639 DRESULTS="$BASE$DNUM"
640 while test -e $DRESULTS ; do
641 DNUM=$(( $DNUM + 1 ))
642 DRESULTS="$BASE$DNUM"
643 done
644 mkdir $DRESULTS
645 RETVAL=$?
646 if test "x$RETVAL" != x0 ; then
647 echo "ERROR: Can't create results directory \"./$DRESULTS\""
648 exit 1
649 fi
650 SUMMARY="$DRESULTS/summary.txt"
651 echo -n "Start time: " >> $SUMMARY
652 start_date=`date`
653 echo $start_date > $SUMMARY
654
655 of_path=
656 if test "x$OPTFILE" != xNONE ; then
657 if test -r $OPTFILE ; then
658 # get the path
659 path=${OPTFILE%/*}
660 if test "x$path" = x ; then
661 of_path=`pwd`
662 else
663 of_path=`( cd $path > /dev/null 2>&1 ; pwd )`
664 fi
665 file=${OPTFILE##*/}
666 OPTFILE=$of_path/$file
667 cp $OPTFILE $DRESULTS
668 echo >> $SUMMARY
669 echo " OPTFILE=$OPTFILE" >> $SUMMARY
670 else
671 echo | tee $SUMMARY
672 echo "ERROR: can't read OPTFILE=\"$OPTFILE\"" | tee $SUMMARY
673 exit 1
674 fi
675 else
676 echo >> $SUMMARY
677 echo "No \"OPTFILE\" was explicitly specified by testreport," >> $SUMMARY
678 echo " so the genmake default will be used." >> $SUMMARY
679 fi
680 echo
681 echo >> $SUMMARY
682 if test "x$ADM" = x ; then
683 cat << EOF | tee -a $SUMMARY
684 T S U V
685 G D M c m s m s m s m s
686 E p a R g m m e . m m e . m m e . m m e .
687 N n k u 2 i a a d i a a d i a a d i a a d
688 2 d e n d n x n . n x n . n x n . n x n .
689
690 EOF
691 else
692 echo "ADJOINT=true" >> $SUMMARY
693 echo >> $SUMMARY
694 cat << EOF | tee -a $SUMMARY
695 G D M C G
696 E p a R o r
697 N n k u s a
698 2 d e n t d
699
700 EOF
701 fi
702
703 # ...and each test directory...
704 for dir in $TESTDIRS ; do
705
706 # Cleanup only!
707 if test "x$CLEANUP" = xt ; then
708 if test -r $dir/build/Makefile ; then
709 ( cd $dir/build ; make CLEAN )
710 fi
711 if test -r $dir/input/Makefile ; then
712 ( cd $dir/input ; make CLEAN )
713 fi
714 continue
715 fi
716
717 # Verify that the testdir exists and contains previous
718 # results in the correct location--or skip this directory!
719 fout=
720 if test "x$ADM" = x ; then
721 fout=$dir"/results/output.txt"
722 else
723 fout=$dir"/results_ad/output.txt_adm"
724 fi
725 if test ! -r $fout ; then
726 echo "can't read \"$fout\" -- skipping $dir"
727 continue
728 fi
729
730 echo "-------------------------------------------------------------------------------"
731 echo
732 echo "Experiment: $dir"
733 echo
734 unset genmake makedepend make run
735 results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'
736
737 builddir="input"
738 rundir="input"
739 use_seperate_build=0
740 if test -d $dir/build -a -r $dir/build ; then
741 builddir="build"
742 rundir="build"
743 use_seperate_build=1
744 linkdata $use_seperate_build $dir/$rundir
745 fi
746
747 if test "x$ADM" = x ; then
748 CODE_DIR=$dir/code
749 else
750 CODE_DIR=$dir/code_ad
751 fi
752 BUILD_DIR=$dir/$builddir
753 MPI_FILES="CPP_EEOPTIONS.h_mpi SIZE.h_mpi"
754 NOMPI_FILES="CPP_EEOPTIONS.h_nompi SIZE.h_nompi"
755
756 # Is this an MPI run?
757 if test "x$MPI" = xt ; then
758 FILES=$MPI_FILES
759 endings="_mpi"
760 else
761 FILES=$NOMPI_FILES
762 endings="_nompi"
763 fi
764
765 # Check to see that we have the files
766 have_files=t
767 for i in $FILES ; do
768 if test ! -r $CODE_DIR/$i ; then
769 echo "Warning: can't read file $CODE_DIR/$i"
770 have_files=f
771 fi
772 done
773 if test "x$have_files" != xt -a "x$MPI" = xt ; then
774 echo "Skipping $dir due to lack of input files (see above warning)"
775 continue
776 fi
777
778 # If we have the $FILES and they differ, copy the $FILES to $BUILD_DIR
779 if test "x$have_files" = xt ; then
780 for i in $FILES ; do
781 sstr="s|$endings||"
782 name=`echo $i | sed -e $sstr `
783 cmp $CODE_DIR/$i $BUILD_DIR/$name > /dev/null 2>&1
784 RETVAL=$?
785 if test "x$RETVAL" != x0 ; then
786 cp $CODE_DIR/$i $BUILD_DIR/$name
787 fi
788 done
789 fi
790
791 # Create an output dir for each OPTFILE/tdir combination
792 rel_CDIR=$DRESULTS"/"$dir
793 mkdir $rel_CDIR
794 CDIR=`pwd`"/$rel_CDIR"
795
796 if test "x$CLEANUP" = xt ; then
797 makeclean $dir/$builddir
798 else
799 genmakemodel $dir/$builddir && genmake=Y \
800 && makeclean $dir/$builddir \
801 && makedependmodel $dir/$builddir && makedepend=Y \
802 && makemodel $dir/$builddir && make=Y \
803 && linkdata $use_seperate_build $dir/$rundir \
804 && runmodel $dir/$rundir && run=Y \
805 && results=`testoutput $dir $rundir`
806 fi
807
808 echo
809 if test "x$ADM" = x ; then
810 fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
811 else
812 fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`
813 fres=$fres"$results $dir"
814 fi
815 echo
816 echo "$fres" >> $SUMMARY
817 echo "fresults='$fres'" > $CDIR"/summary.txt"
818 echo "MACH='$MACH'" >> $CDIR"/summary.txt"
819 echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
820 echo "DATE='$DATE'" >> $CDIR"/summary.txt"
821 echo "tdir='$dir'" >> $CDIR"/summary.txt"
822
823 echo "-------------------------------------------------------------------------------"
824
825 done
826
827 echo -n "Start time: " >> $SUMMARY
828 echo $start_date >> $SUMMARY
829 echo -n "End time: " >> $SUMMARY
830 date >> $SUMMARY
831
832 # If addresses were supplied and mpack built successfully, then try
833 # to send email using mpack.
834 if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then
835 echo "No results email was sent."
836 else
837 if test "x$HAVE_MPACK" = xt ; then
838 tar -cf $DRESULTS".tar" $DRESULTS > /dev/null 2>&1 \
839 && gzip $DRESULTS".tar" \
840 && $MPACK -s MITgcm-test -m 1500000 $DRESULTS".tar.gz" $ADDRESSES
841 RETVAL=$?
842 if test "x$RETVAL" != x0 ; then
843 echo
844 echo "Warning: The tar, gzip, & mpack step failed. Please send email"
845 echo " to <MITgcm-support@mitgcm.org> for help. You may copy the "
846 echo " summary of results from the directory \"$DRESULTS\"."
847 echo
848 else
849 echo
850 echo "An email containing results was sent to the following addresses:"
851 echo " \"$ADDRESSES\""
852 echo
853 fi
854 test -f $DRESULTS".tar" && rm -f $DRESULTS".tar"
855 test -f $DRESULTS".tar.gz" && rm -f $DRESULTS".tar.gz"
856 fi
857 fi
858
859 # rm -f tmp_cmpnum.f a.out
860 rm -f tmp_cmpnum.c tmp_cmpnum
861
862 if test "x$CLEANUP" != xt ; then
863 cat $SUMMARY
864 if test -e tr_out.txt ; then
865 mv tr_out.txt tr_out.txt.old
866 fi
867 cat $SUMMARY > tr_out.txt
868 fi

  ViewVC Help
Powered by ViewVC 1.1.22